/***************************************************************************
 *   Copyright (C) 2010 by Stephane List                                   *
 *   slist@lilotux.net                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "test_port.h"

test_port::test_port(QObject *parent) :
    QObject(parent)
{
}

void test_port::run_test(const QString &ip, quint16 port)
{
    ip_ = ip;
    port_ = port;

    connect(&sock_, SIGNAL(connected()), this, SLOT(on_tcp_connected()));
    connect(&sock_, SIGNAL(error(QAbstractSocket::SocketError)), this, SLOT(on_tcp_error(QAbstractSocket::SocketError)));
    sock_.connectToHost(ip_, port_);
}

void test_port::on_tcp_error(QAbstractSocket::SocketError /* socketError */)
{
    result_ = false;
    end();
}

void test_port::on_tcp_connected()
{
    result_ = true;
    end();
}

void test_port::end()
{
    emit result(ip_,port_,result_);
    this->deleteLater();
}
